package com.realnet.stepperworkflow.Services;

import com.realnet.stepperworkflow.Repository.Stepper_workflowRepository;
import com.realnet.stepperworkflow.Entity.Stepper_workflow;
import java.util.*;

import org.springframework.beans.factory.annotation.Autowired;
import com.realnet.SequenceGenerator.Service.SequenceService;
import org.springframework.data.domain.Page;
import com.realnet.realm.Entity.Realm;
import com.realnet.realm.Services.RealmService;
import org.springframework.data.domain.Pageable;
import org.springframework.http.*;
import com.realnet.users.service1.AppUserServiceImpl;
import com.realnet.users.entity1.AppUser;

import org.springframework.stereotype.Service;

@Service
public class Stepper_workflowService {
	@Autowired
	private Stepper_workflowRepository Repository;
	@Autowired
	private AppUserServiceImpl userService;
	@Autowired
	private RealmService realmService;

	public Stepper_workflow Savedata(Stepper_workflow data) {

		data.setUpdatedBy(getUser().getUserId());
		data.setCreatedBy(getUser().getUserId());
		data.setAccountId(getUser().getAccount().getAccount_id());

		Stepper_workflow save = Repository.save(data);
		return save;
	}

//	get all with pagination
	public Page<Stepper_workflow> getAllWithPagination(Pageable page) {
		return Repository.findAll(page, getUser().getUserId());
	}

	public List<Stepper_workflow> getdetails() {
		List<Realm> realm = realmService.findByUserId(getUser().getUserId());
		List<Stepper_workflow> all = Repository.findAll(getUser().getUserId());

		return all;
	}

	public Stepper_workflow getdetailsbyId(Integer id) {
		return Repository.findById(id).get();
	}

	public void delete_by_id(Integer id) {
		Repository.deleteById(id);
	}

	public Stepper_workflow update(Stepper_workflow data, Integer id) {
		Stepper_workflow old = Repository.findById(id).get();
		old.setName(data.getName());

		old.setDescription(data.getDescription());

		old.setActive(data.isActive());

		final Stepper_workflow test = Repository.save(old);
		data.setUpdatedBy(getUser().getUserId());
		return test;
	}

	public AppUser getUser() {
		AppUser user = userService.getLoggedInUser();
		return user;

	}
}
